package com.haomostudio.SpringMVCProjectTemplate.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.common.base.CaseFormat;
import com.haomostudio.SpringMVCProjectTemplate.dao.CountryMapper;
import com.haomostudio.SpringMVCProjectTemplate.domain.Country;
import com.haomostudio.SpringMVCProjectTemplate.domain.CountryExample;
import com.haomostudio.SpringMVCProjectTemplate.service.HmUtils.MybatisExampleHelper;
import org.apache.ibatis.session.RowBounds;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.lang.reflect.Method;
import java.util.*;

/**
 * Created by hxgqh on 2016/10/6.
 */

@Service("countryService")
public class CountryServiceImpl implements CountryService{
    @Autowired
    CountryMapper countryMapper;

    @Override
    public List<Country> getListWithPagingAndFilter(
            Integer pageNo, Integer pageSize,
            String sortItem, String sortOrder,
            String filters){
        CountryExample exampleObj = new CountryExample();
        RowBounds rowBounds = new RowBounds((pageNo - 1) * pageSize, pageSize);
        MybatisExampleHelper.assignWhereClause(exampleObj, exampleObj.or(), "Country", filters);
        exampleObj.setOrderByClause(MybatisExampleHelper.createOrderClause(sortItem, sortOrder));

        return countryMapper.selectByExampleWithRowbounds(
                exampleObj, rowBounds);
    }
}
